package Events;

import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.EntityDamageByEntityEvent;

import com.shampaggon.crackshot.events.WeaponDamageEntityEvent;

import GameManagement.End;
import GameManagement.Manager;
import GameManagement.State;
import GameManagement.Team;
import PlayerManagement.Players;
import PlayerManagement.Spectate;
import PlayerManagement.Teams;
import Stats.CurrentGame;

public class EntityByEntity implements Listener{

	@EventHandler
	public void onShot(WeaponDamageEntityEvent event){
		if (event.getVictim() instanceof Player){
			Player damaged = (Player) event.getVictim();
			Team t = Players.getTeam(damaged);
			Player p = event.getPlayer();
			Team y = Players.getTeam(p);
			
			if (y.equals(t)){
				
				event.setCancelled(true);
				return;
			}
			double i = event.getDamage();
			if (damaged.getHealth() > i){
				event.setDamage(i);
				
				
				
				p.playSound(p.getLocation(), Sound.SUCCESSFUL_HIT, 1.0F, 0.0F);
			}
			else {
				//Player has been killed
				Spectate.set(damaged);
				
				CurrentGame.addDeath(damaged);
				CurrentGame.addKill(p);
				p.playSound(p.getLocation(), Sound.SUCCESSFUL_HIT, 1.0F, 0.0F);
				
				Teams.setAlive(t, Teams.getAlive(t) - 1);
				boolean x = false;
				if (Manager.getCops() == t) x = true;//if true losing team is cops
				if (Manager.getState() == State.DEFAULT){
					
					if (Teams.getAlive(t) <= 0){
						
						if (t == Team.ONE){
							if (x) End.round(Team.TWO, "Criminals");
							else End.round(Team.TWO, "Cops");
							
						}
						else{
							if (x) End.round(Team.ONE, "Criminals");
							else End.round(Team.ONE, "Cops");
						
						}
						
					}
				}
				else if (Manager.getState() == State.PLANTED){
					if (Manager.getCops() == t){
						if (Teams.getAlive(t) <= 0){
							if (t == Team.ONE){
								End.round(Team.TWO, "Criminals");
							}
							else{
								End.round(Team.ONE, "Criminals");
							}
						}
					}
				}
				event.setCancelled(true);
				
			}
		
		}
	}
	
	
	@EventHandler
	public void onDamage(EntityDamageByEntityEvent event){
		if (event.getEntity() instanceof Player){
			Player damaged = (Player) event.getEntity();
			
			/*if (event.getDamager() instanceof Arrow){
				Arrow a = (Arrow) event.getDamager();
				if (ArrowManager.shooter.containsKey(a.getUniqueId()) && Players.getTeam(damaged) != null){
				if (ArrowManager.shooter.get(a.getUniqueId()) != Players.getTeam(damaged)){
					
				
				
				if (ArrowManager.arrows.containsKey(a.getUniqueId())){
				
					double i = (double) ArrowManager.arrows.get(a.getUniqueId());
					if (damaged.getHealth() > i){
						event.setDamage(i);
						Player p = Bukkit.getPlayer(ArrowManager.ogShooter.get(a.getUniqueId()));
						
						
						p.playSound(p.getLocation(), Sound.SUCCESSFUL_HIT, 1.0F, 0.0F);
					}
					else {
						//Player has been killed
						Spectate.set(damaged);
						Player p = Bukkit.getPlayer(ArrowManager.ogShooter.get(a.getUniqueId()));
						CurrentGame.addDeath(damaged);
						CurrentGame.addKill(p);
						p.playSound(p.getLocation(), Sound.SUCCESSFUL_HIT, 1.0F, 0.0F);
						Team t = Players.getTeam(damaged);
						Teams.setAlive(t, Teams.getAlive(t) - 1);
						boolean x = false;
						if (Manager.getCops() == t) x = true;//if true losing team is cops
						if (Manager.getState() == State.DEFAULT){
							
							if (Teams.getAlive(t) <= 0){
								
								if (t == Team.ONE){
									if (x) End.round(Team.TWO, "Criminals");
									else End.round(Team.TWO, "Cops");
									
								}
								else{
									if (x) End.round(Team.ONE, "Criminals");
									else End.round(Team.ONE, "Cops");
								
								}
								
							}
						}
						else if (Manager.getState() == State.PLANTED){
							if (Manager.getCops() == t){
								if (Teams.getAlive(t) <= 0){
									if (t == Team.ONE){
										End.round(Team.TWO, "Criminals");
									}
									else{
										End.round(Team.ONE, "Criminals");
									}
								}
							}
						}
						event.setCancelled(true);
						
					}
				
				}
				}
				}
			}*/
			if (event.getDamager() instanceof Player){
				Player damager = (Player) event.getDamager();
				Team l = Players.getTeam(damaged);
				Team y = Players.getTeam(damager);
				if (l == null || y == null){
							event.setCancelled(true);
							return;
				}
				if (y.equals(l)){
					event.setCancelled(true);
					return;
				}
				double i = event.getDamage();
				if (i >= damaged.getHealth()){
					CurrentGame.addKill(damager);
					CurrentGame.addDeath(damaged);
					Spectate.set(damaged);
					Team t = Players.getTeam(damaged);
					Teams.setAlive(t, Teams.getAlive(t) - 1);
					boolean x = false;
					if (Manager.getCops() == t) x = true;//if true losing team is cops
					if (Manager.getState() == State.DEFAULT){
						
						if (Teams.getAlive(t) <= 0){
							
							if (t == Team.ONE){
								if (x) End.round(Team.TWO, "Criminals");
								else End.round(Team.TWO, "Cops");
								
							}
							else{
								if (x) End.round(Team.ONE, "Criminals");
								else End.round(Team.ONE, "Cops");
							
							}
							
						}
					}
					else if (Manager.getState() == State.PLANTED){
						if (Manager.getCops() == t){
							if (Teams.getAlive(t) <= 0){
								if (t == Team.ONE){
									End.round(Team.TWO, "Criminals");
								}
								else{
									End.round(Team.ONE, "Criminals");
								}
							}
						}
					}
					
				}
			}
			
		}
	}
	
}
