package Events;

import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;

import GameManagement.GameStage;
import ConfigManagement.Messages;
import ConfigManagement.Settings;
import GameManagement.Start;
import PlayerManagement.InventoryManager;
import PlayerManagement.Teams;

public class Join implements Listener{
	
	@EventHandler
	public void onJoin(PlayerJoinEvent event){
		Player p = event.getPlayer();
		p.getInventory().clear();
		if (GameManagement.Manager.getStage() == GameStage.LOBBY){
			event.getPlayer().teleport(ConfigManagement.Locations.lobby());
		
			if (Bukkit.getOnlinePlayers().size() >= Settings.minPlayers()){
				Start.countdown();
			}
			else{
				event.setJoinMessage(Messages.getJoinLobby(Settings.minPlayers() - Bukkit.getOnlinePlayers().size(), event.getPlayer().getName()));
			}
		}
		else if (GameManagement.Manager.getStage() == GameStage.STARTING){
			p.teleport(ConfigManagement.Locations.lobby());
			event.setJoinMessage("");//add later
		}
		else if (GameManagement.Manager.getStage() == GameStage.BETWEEN_ROUNDS){
			Teams.addToTeam(p);
			InventoryManager.equipDefaults();
		}
		else if (GameManagement.Manager.getStage() == GameStage.INGAME){
			Teams.lateJoin(p);
			p.teleport(ConfigManagement.Locations.lobby());
		}
		else if (GameManagement.Manager.getStage() == GameStage.POSTGAME){
			Teams.lateJoin(p);
			p.teleport(ConfigManagement.Locations.lobby());
		}
	}
}
