package tfw.Main;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import GameManagement.GameStage;
import ConfigManagement.Messages;
import ConfigManagement.Settings;
import Events.ItemConsume;
import GameManagement.End;
import GameManagement.Manager;
import GameManagement.Start;
import GameManagement.State;
import ScoreManagement.InGameBoard;
import ScoreManagement.PregameBoard;

public class SimplyCountdown
{
    private final Plugin plugin;
    
    private String prefix = Messages.getPrefix();
    private int countdownTimer;
    private static int timeOnClock;
    public SimplyCountdown(Plugin plugin2)
    {
        this.plugin = plugin2;
    }
    public int timeLeft(){
    	return timeOnClock;
    }
    public void startCountdown(final boolean all, final int time, final String msg)
    {
    	timeOnClock = time;
    	if (Manager.getStage() == GameStage.BETWEEN_ROUNDS){
        	
        	for (Player p : Bukkit.getOnlinePlayers()){
        	//	Pregame.update(p);
        		PregameBoard.createScoreboard(p);
        	}
    	}
    	if (Manager.getStage() == GameStage.INGAME){
        	
        	for (Player p : Bukkit.getOnlinePlayers()){
        	//	Pregame.update(p);
        		InGameBoard.createScoreboard(p);
        	}
    	}
        this.countdownTimer = Bukkit.getServer().getScheduler().scheduleSyncRepeatingTask(this.plugin, new Runnable()
        {
            int i = time;
            
            public void run()
            {
            	
                if(all)
                {
                    Bukkit.broadcastMessage(SimplyCountdown.this.prefix + ChatColor.translateAlternateColorCodes('&', msg.replace("#", Integer.toString(i))));
                }
                for (Player p : Bukkit.getOnlinePlayers()){
                	p.setLevel(i);
                	if (Manager.getState() == State.PLANTED){
                		p.playSound(p.getLocation(), Sound.CLICK, 1.0F, 0.0F);
                	}
                }
                if (Manager.getStage() == GameStage.BETWEEN_ROUNDS){
                	
                	for (Player p : Bukkit.getOnlinePlayers()){
                	//	Pregame.update(p);
                		PregameBoard.updatePoints(p);
                	}
                	}
                if (Manager.getStage() == GameStage.INGAME){
                	for (Player p : Bukkit.getOnlinePlayers()){
                		InGameBoard.updatePoints(p);
                		
                	}
                }
                
                this.i--;
                timeOnClock--;
                if (this.i <= 0){
                	SimplyCountdown.this.cancel();
                	if (Manager.getStage() == GameStage.INGAME){
                		if (Manager.getState() == State.DEFAULT){
                			End.round(Manager.getCops(), "Cops");
                		}
                		else {
                			if (ItemConsume.chest != null) ItemConsume.chest.getLocation().getWorld().createExplosion(ItemConsume.chest.getLocation(), 0.0F);
                			for (Player p : Bukkit.getOnlinePlayers()){
                				p.playSound(p.getLocation(), Sound.EXPLODE, 1.0F, 0.0F);
                			}
                			End.round(Manager.getCrims(), "Criminals");
                		}
                	}
                	else if (Manager.getStage() == GameStage.BETWEEN_ROUNDS){
                		Start.game();
                	}
                	else if (Manager.getStage() == GameStage.STARTING){
            			if (Bukkit.getOnlinePlayers().size() >= Settings.minPlayers()){
            				Start.preGame();

            			}
            			else{
            				Manager.setStage(GameStage.LOBBY);
            				Bukkit.broadcastMessage(ChatColor.RED + "Not enough players to start the game!");
            			}
                	}
                }
            }
        }
        , 0L, 20L);
    }
 
    public void cancel()
    {

        Bukkit.getScheduler().cancelTask(this.countdownTimer);
    }
}